## notary 0.7.0+git20240416.9d2b3b3+ds1

=== Makefile ===
# Set an output prefix, which is the local directory if not specified
PREFIX?=$(shell pwd)

GOFLAGS := -mod=vendor

# Populate version variables
# Add to compile time flags
NOTARY_PKG := github.com/theupdateframework/notary
NOTARY_VERSION := $(shell cat NOTARY_VERSION)
GITCOMMIT := $(shell git rev-parse --short HEAD)
GITUNTRACKEDCHANGES := $(shell git status --porcelain --untracked-files=no)
ifneq ($(GITUNTRACKEDCHANGES),)
GITCOMMIT := $(GITCOMMIT)-dirty
endif
CTIMEVAR=-X $(NOTARY_PKG)/version.GitCommit=$(GITCOMMIT) -X $(NOTARY_PKG)/version.NotaryVersion=$(NOTARY_VERSION)
GO_LDFLAGS=-ldflags "-w $(CTIMEVAR)"
GO_LDFLAGS_STATIC=-ldflags "-w $(CTIMEVAR) -extldflags -static"
GOOSES = darwin linux windows
NOTARY_BUILDTAGS ?= pkcs11
NOTARYDIR := /go/src/github.com/theupdateframework/notary

# check to be sure pkcs11 lib is always imported with a build tag
GO_LIST_PKCS11 := $(shell go list -tags "${NOTARY_BUILDTAGS}" -e -f '{{join .Deps "\n"}}' ./... | grep -v /vendor/ | xargs go list -e -f '{{if not .Standard}}{{.ImportPath}}{{end}}' | grep -q pkcs11)
ifeq ($(GO_LIST_PKCS11),)
$(info pkcs11 import was not found anywhere without a build tag, yay)
else
$(error You are importing pkcs11 somewhere and not using a build tag)
endif

_empty :=
_space := $(empty) $(empty)

# go cover test variables
COVERPROFILE?=coverage.txt
COVERMODE=atomic
PKGS ?= $(shell go list -tags "${NOTARY_BUILDTAGS}" ./... | grep -v /vendor/ | tr '\n' ' ')

.PHONY: clean all lint build test binaries cross cover docker-images notary-dockerfile
.DELETE_ON_ERROR: cover
.DEFAULT: default

all: clean lint build test binaries

# This only needs to be generated by hand when cutting full releases.
version/version.go:
	./version/version.sh > $@

${PREFIX}/bin/notary-server: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary-server

${PREFIX}/bin/notary: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary

${PREFIX}/bin/notary-signer: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary-signer

${PREFIX}/bin/escrow: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/escrow

ifeq ($(shell uname -s),Darwin)
${PREFIX}/bin/static/notary-server:
	@echo "notary-server: static builds not supported on OS X"

${PREFIX}/bin/static/notary-signer:
	@echo "notary-signer: static builds not supported on OS X"

${PREFIX}/bin/static/notary:
	@echo "notary: static builds not supported on OS X"
else
${PREFIX}/bin/static/notary-server: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@(export CGO_ENABLED=0; go build -tags "${NOTARY_BUILDTAGS} netgo" -o $@ ${GO_LDFLAGS_STATIC} ./cmd/notary-server)

${PREFIX}/bin/static/notary-signer: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@(export CGO_ENABLED=0; go build -tags "${NOTARY_BUILDTAGS} netgo" -o $@ ${GO_LDFLAGS_STATIC} ./cmd/notary-signer)

${PREFIX}/bin/static/notary:
	@echo "+ $@"
	@go build -tags "${NOTARY_BUILDTAGS} netgo" -o $@ ${GO_LDFLAGS_STATIC} ./cmd/notary
endif

ifeq (, $(shell which staticcheck))
STATICCHECK_BIN := $(GOBIN)/staticcheck
$(STATICCHECK_BIN):
	@echo "+ $@"
	GOFLAGS="-mod=mod" go install honnef.co/go/tools/cmd/staticcheck@latest
endif

# spin up a docker instance and run staticcheck inside it
.PHONY: staticcheck-docker
staticcheck-docker: $(STATICCHECK_BIN)
	@$(dockerbuild)
ifeq ($(RUN_LOCAL),1)
	staticcheck -checks=all,-ST1000 ./...
endif

.PHONY: staticcheck
staticcheck: $(STATICCHECK_BIN)
	staticcheck -checks=all,-ST1000 ./...

ifneq ($(RUN_LOCAL),1)
dockerbuild = @DOCKER_BUILDKIT=1 docker build \
			-f build.Dockerfile \
			--build-arg target=$@ \
			--target=builder \
			.
dockertestbuild = @DOCKER_BUILDKIT=1 docker build \
			-f build.Dockerfile \
			--build-arg target=$@ \
			--target=test-builder \
			.
endif

# run lint locally
lint: staticcheck

# run lint target in docker
lint-docker: staticcheck-docker

build:
	@echo "+ $@"
	@go build -tags "${NOTARY_BUILDTAGS}" -v ${GO_LDFLAGS} $(PKGS)

# When running `go test ./...`, it runs all the suites in parallel, which causes
# problems when running with a yubikey
test: TESTOPTS =
test:
	@echo Note: when testing with a yubikey plugged in, make sure to include 'TESTOPTS="-p 1"'
	@echo "+ $@ $(TESTOPTS)"
	@echo
	go test -tags "${NOTARY_BUILDTAGS}" $(TESTOPTS) $(PKGS)

# run test target in docker
test-docker: TESTOPTS =
test-docker:
	@$(dockertestbuild)
ifeq ($(RUN_LOCAL),1)
	@echo Note: when testing with a yubikey plugged in, make sure to include 'TESTOPTS="-p 1"'
	@echo "+ $@ $(TESTOPTS)"
	@echo
	go test -tags "${NOTARY_BUILDTAGS}" $(TESTOPTS) $(PKGS)
endif

integration: TESTDB = mysql
integration: clean
	buildscripts/integrationtest.sh $(TESTDB)

testdb: TESTDB = mysql
testdb:
	buildscripts/dbtests.sh $(TESTDB)

protos:
	@protoc --go_out=. --go-grpc_out=. proto/*.proto

# This allows coverage for a package to come from tests in different package.
# Requires that the following:
# go get github.com/wadey/gocovmerge; go install github.com/wadey/gocovmerge
#
# be run first
gen-cover:
gen-cover:
	@python -u buildscripts/covertest.py --tags "$(NOTARY_BUILDTAGS)" --pkgs="$(PKGS)" --testopts="${TESTOPTS}"

# Generates the cover binaries and runs them all in serial, so this can be used
# run all tests with a yubikey without any problems
cover: gen-cover covmerge
	@go tool cover -html="$(COVERPROFILE)"

# Generates the cover binaries and runs them all in serial, so this can be used
# run all tests with a yubikey without any problems
ci: override TESTOPTS = -race
# Codecov knows how to merge multiple coverage files, so covmerge is not needed
ci: gen-cover

yubikey-tests: override PKGS = github.com/theupdateframework/notary/cmd/notary github.com/theupdateframework/notary/trustmanager/yubikey
yubikey-tests: ci

covmerge:
	@gocovmerge $(shell find . -name coverage*.txt | tr "\n" " ") > $(COVERPROFILE)
	@go tool cover -func="$(COVERPROFILE)"

clean-protos:
	@rm proto/*.pb.go

client: ${PREFIX}/bin/notary
	@echo "+ $@"

binaries: ${PREFIX}/bin/notary-server ${PREFIX}/bin/notary ${PREFIX}/bin/notary-signer
	@echo "+ $@"

escrow: ${PREFIX}/bin/escrow
	@echo "+ $@"

static: ${PREFIX}/bin/static/notary-server ${PREFIX}/bin/static/notary-signer ${PREFIX}/bin/static/notary
	@echo "+ $@"

notary-dockerfile:
	@docker build --rm --force-rm -t notary .

server-dockerfile:
	@docker build --rm --force-rm -f server.Dockerfile -t notary-server .

signer-dockerfile:
	@docker build --rm --force-rm -f signer.Dockerfile -t notary-signer .

docker-images: notary-dockerfile server-dockerfile signer-dockerfile

shell: notary-dockerfile
	docker run --rm -it -v $(CURDIR)/cross:$(NOTARYDIR)/cross -v $(CURDIR)/bin:$(NOTARYDIR)/bin notary bash

cross:
	@rm -rf $(CURDIR)/cross
	@docker build --rm --force-rm -t notary -f cross.Dockerfile .
	docker run --rm -v $(CURDIR)/cross:$(NOTARYDIR)/cross -e CTIMEVAR="${CTIMEVAR}" -e NOTARY_BUILDTAGS=$(NOTARY_BUILDTAGS) notary buildscripts/cross.sh $(GOOSES)

clean:
	@echo "+ $@"
	@rm -rf .cover cross
	find . -name coverage.txt -delete
	@rm -rf "${PREFIX}/bin/notary-server" "${PREFIX}/bin/notary" "${PREFIX}/bin/notary-signer"
	@rm -rf "${PREFIX}/bin/static"

=== debian/changelog ===
notary (0.7.0+git20240416.9d2b3b3+ds1-4) unstable; urgency=medium

  * Team upload
  * Add patch to fix FTBFS with updated golang-github-spf13-viper

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 11 Oct 2025 21:13:21 +0000

notary (0.7.0+git20240416.9d2b3b3+ds1-3) unstable; urgency=medium

  * Team upload.
  * Fix timebomb FTBFS.  Closes: #1078632.
  * Fix debian/* copyright years.

 -- Simon Josefsson <simon@josefsson.org>  Sat, 15 Feb 2025 17:18:17 +0100

notary (0.7.0+git20240416.9d2b3b3+ds1-2) unstable; urgency=medium

  * Team upload
  * Upload changes from experimental to unstable
  * Add a patch for building with newer versions of cloudflare-cfssl
    library
  * Set minimum version of golang-github-cloudflare-cfssl in d/control

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 26 Jul 2024 08:10:14 +0000

notary (0.7.0+git20240416.9d2b3b3+ds1-1) experimental; urgency=medium

  * New upstream version, packaging latest HEAD from upstream
    Closes: #917716, #929716
  * Add patch to allow compilation with libpq 1.10
  * Build-depend on protoc gRPC plugin
  * Refresh Patches
  * Build against golang/protobuf@v1.5
  * Delete vendor tree in clean target, Closes: #1049293

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 04 Jun 2024 21:30:50 -0400

=== debian/control ===
Source: notary
Section: devel
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Arnaud Rebillout <arnaudr@kali.org>,
           Michael Hudson-Doyle <mwhudson@debian.org>,
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-bugsnag-bugsnag-go-dev,
               golang-github-cloudflare-cfssl-dev (>= 1.6.5),
               golang-github-docker-distribution-dev (>= 2.7.1~),
               golang-github-docker-go-connections-dev,
               golang-github-docker-go-dev,
               golang-github-dvsekhvalnov-jose2go-dev,
               golang-github-go-sql-driver-mysql-dev,
               golang-github-golang-protobuf-1-5-dev,
               golang-github-gorilla-mux-dev,
               golang-github-jinzhu-gorm-dev,
               golang-github-lib-pq-dev,
               golang-github-mattn-go-sqlite3-dev,
               golang-github-miekg-pkcs11-dev,
#               golang-github-prometheus-client-golang-dev,    # vendored
               golang-github-shopify-logrus-bugsnag-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-spf13-cobra-dev,
               golang-github-spf13-viper-dev (>= 1.21.0),
               golang-github-stretchr-testify-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sys-dev,
               golang-google-grpc-dev,
               golang-gopkg-rethinkdb-rethinkdb-go.v6-dev (>> 6.2.1-3~),
               openssl,
               protoc-gen-go-grpc,
               protoc-gen-go-1-5
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.0
Homepage: https://github.com/notaryproject/notary
Vcs-Browser: https://salsa.debian.org/go-team/packages/notary
Vcs-Git: https://salsa.debian.org/go-team/packages/notary.git
XS-Go-Import-Path: github.com/theupdateframework/notary

Package: notary
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: tool for running and interacting with trusted collections
 Notary is a project that allows anyone to have trust over arbitrary
 collections of data.
 .
 The Notary project comprises a server (cmd/notary-server) and a client
 (cmd/notary) for running and interacting with trusted collections.
 .
 Notary aims to make the internet more secure by making it easy for people to
 publish and verify content. We often rely on TLS to secure our communications
 with a web server which is inherently flawed, as any compromise of the server
 enables malicious content to be substituted for the legitimate content.
 .
 With Notary, publishers can sign their content offline using keys kept highly
 secure. Once the publisher is ready to make the content available, they can
 push their signed trusted collection to a Notary Server.
 .
 Consumers, having acquired the publisher's public key through a secure
 channel, can then communicate with any notary server or (insecure) mirror,
 relying only on the publisher's key to determine the validity and integrity
 of the received content.
 .
 This package contains the binaries/tools.

Package: golang-github-docker-notary-dev
Provides: golang-github-theupdateframework-notary-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         golang-github-bugsnag-bugsnag-go-dev,
         golang-github-cloudflare-cfssl-dev (>= 1.6.5),
         golang-github-docker-go-connections-dev,
         golang-github-docker-go-dev,
         golang-github-dvsekhvalnov-jose2go-dev,
         golang-github-go-sql-driver-mysql-dev,
         golang-github-golang-protobuf-1-5-dev,
         golang-github-gorilla-mux-dev,
         golang-github-jinzhu-gorm-dev,
         golang-github-lib-pq-dev,
         golang-github-mattn-go-sqlite3-dev,
         golang-github-miekg-pkcs11-dev,
#         golang-github-prometheus-client-golang-dev,    # vendored
         golang-github-shopify-logrus-bugsnag-dev,
         golang-github-sirupsen-logrus-dev,
         golang-github-spf13-cobra-dev,
         golang-github-spf13-viper-dev (>= 1.21.0),
         golang-github-stretchr-testify-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sys-dev,
         golang-google-grpc-dev,
         golang-gopkg-rethinkdb-rethinkdb-go.v6-dev
Description: library for running and interacting with trusted collections
 Notary is a project that allows anyone to have trust over arbitrary
 collections of data.
 .
 The Notary project comprises a server (cmd/notary-server) and a client
 (cmd/notary) for running and interacting with trusted collections.
 .
 Notary aims to make the internet more secure by making it easy for people to
 publish and verify content. We often rely on TLS to secure our communications
 with a web server which is inherently flawed, as any compromise of the server
 enables malicious content to be substituted for the legitimate content.
 .
 With Notary, publishers can sign their content offline using keys kept highly
 secure. Once the publisher is ready to make the content available, they can
 push their signed trusted collection to a Notary Server.
 .
 Consumers, having acquired the publisher's public key through a secure
 channel, can then communicate with any notary server or (insecure) mirror,
 relying only on the publisher's key to determine the validity and integrity
 of the received content.
 .
 This package contains the source.

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_GO_GENERATE := 1
export DH_GOLANG_INSTALL_EXTRA := fixtures
GOPKG     := github.com/theupdateframework/notary
BUILDDIR  := $(CURDIR)/_build
BUILDTAGS := pkcs11

%:
	dh $@ --builddirectory=$(BUILDDIR) \
	      --buildsystem=golang \
	      --with=golang

override_dh_auto_configure:
	# Note(zhsj): some certs are expired and cause test failures.
	# but there's no need to regenerate certs which need cfssljson tool.
	# And I don't want to add another Build-Depends.
	sed -i '/command -v cfssljson/i exit 0' ./fixtures/regenerateTestingCerts.sh
	cd fixtures && ./regenerateTestingCerts.sh
	dh_auto_configure
	# Copy the vendor tree
	cp -av debian/vendor _build/src/$(GOPKG)/

execute_after_dh_clean:
	rm -rfv vendor/

override_dh_auto_build:
	dh_auto_build -- -tags "$(BUILDTAGS)"

override_dh_auto_install:
	# There's no reason to ship this script as it's not needed for the tests,
	# and will cause Lintian to warn about a 'script-not-executable'.
	rm $(BUILDDIR)/src/$(GOPKG)/fixtures/regenerateTestingCerts.sh
	# Some keys and certs are executable, Lintian says 'executable-not-elf-or-script'
	find $(BUILDDIR)/src/$(GOPKG)/fixtures/ -name '*.key' -executable -print | xargs chmod -x
	find $(BUILDDIR)/src/$(GOPKG)/fixtures/ -name '*.crt' -executable -print | xargs chmod -x
	dh_auto_install

=== debian/watch ===
version=4
opts="pretty=0.7.0+git%cd.%h, \
    repacksuffix=+ds1, \
    mode=git,pgpmode=none" \
    https://github.com/notaryproject/notary.git \
    HEAD
